`dosim` <-function() {
	
	poset <- matrix(0,10,10)

	poset[1,2] <-1
	poset[2,3] <-1
	poset[3,4] <-1
	poset[5,4] <-1
	poset[6,7] <-1
	poset[8,9] <-1
	poset[8,10] <-1
	poset[6,9] <-1
	tr<-transitiveClosure(poset)
	theta <- c(0.8, 0.7, 0.6, 0.7, 0.4, 0.25, 0.6, 0.75, 0.5, 0.2)
	eps <- 0.1
	N <- 400

	data<-generateData(tr, theta, eps, N)
	
	registerDoMC(cores=1)
	n_samples=25000
	theta=0
	epsilon=0.05
	n_chains=4
	thin=10
	#registerDoSEQ()

	n<-dim(data)[2]
	n_cases <- dim(data)[1]

	mlist<-list()
	edgelist<-list()
	l=0
	converged = 0
	repeat {
		l=l+1
		rets <- foreach( i = 1:n_chains ) %dopar% {
			print(paste("chain:",i))
			if( theta == 0 ) {
				theta=as.double(runif(n))
			}
		
			if(length(mlist)!=0) {
				edges_in = c(t(edgelist[[i]][n_samples][[1]]))
				theta = as.double(mlist[[i]][n_samples,1:n])
				epsilon = mlist[[i]][n_samples,n+1]
			} else {
				edges_in = as.integer(rep(0,n*n))
			}
		
			ret<-.C("sample_full_cbn", theta, as.integer(n), as.double(epsilon), edges_in, as.integer(n_samples), as.integer(thin), as.integer(c(t(data))), as.integer(n_cases), theta_out=as.double(rep(0,n*n_samples)), epsilon_out=as.double(rep(0,n_samples)), edges_out=as.integer(rep(0,n_samples*n*n)), log_posterior_out=as.double(rep(0,n_samples)))
		
		}
	
		mlist<-list()
		mcmclist<-list()
		edgelist<-list()
	
		X11()
		par(mfrow=c(2,2))
	
		for( i in 1:n_chains) {
			theta_m<-matrix(rets[[i]]$theta_out,ncol=n,byrow=T)
			paramatrix<-cbind(theta_m,rets[[i]]$epsilon_out,rets[[i]]$log_posterior_out)
			mlist[[i]]<-paramatrix
			mcmclist[[i]]<-mcmc(paramatrix)
			sublist<-list()
			edgesum<-0
			for(k in 1:n_samples) {
				sublist[[k]]<-matrix(rets[[i]]$edges_out[((k-1)*n*n+1):(k*n*n)],ncol=n,byrow=T)
				edgesum<-edgesum+matrix(rets[[i]]$edges_out[((k-1)*n*n+1):(k*n*n)],ncol=n,byrow=T)
			}
			edgelist[[i]]<-sublist
			#print(diag(var(paramatrix)))
			print(summary(paramatrix))
		
			image(edgesum)
		}
	#image(edgelist[[1]][[getmode(edgelist[[1]])]],main=paste("mode of chain 1 run ",l))
		mclist<-mcmc.list(mcmclist)
	
		terr<-try(gdiag<-gelman.diag(mclist))
		if (class(terr) != 'try-error') {
			if ( max( gdiag$psrf[,1] ) < 1.1 ) {
				if ( converged==1 ) {
					break
				}
				converged=1
			}
		
			print(gdiag)
		}
	
		print(paste("finished run:",l))
	
	}

	elist<-c(edgelist[[1]],edgelist[[2]],edgelist[[3]],edgelist[[4]])
	X11()
	plotTop(elist,4)
	#
	print(gdiag)
	#jpeg("400_0.1_dens.jpg",quality=100,height=600,width=600)
	
	par(mfrow=c(3,4))
	plot(mclist,trace=F,ask=T,auto.layout=F)
	
	#dev.off()
	#jpeg("400_0.1_structures.jpg",quality=100,height=200,width=1000)
	#plotTop(elist,4)
	#dev.off()
	#
	marginaledges<-marginal(elist)
	#print(marginaledges)
	#jpeg("400_0.1_marginal.jpg",quality=100,height=600,width=600)
	X11()
	par(xaxt="n",yaxt="n")
	image(1:n,1:n,marginaledges,xlab="outgoing nodes",ylab="incoming nodes")
	par(xaxt="s",yaxt="s")
	axis(1,1:n,1:n)
	axis(2,1:n,1:n)
	text(rep(1:n,n),sort(rep(1:n,n)),round(unlist(marginaledges),2))
	#dev.off()
}
